#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    int k;
    cin  >> n >> k;
    long long int S = 0;
    long long int T[n];
    for(int i=0;i<n;i++){
        cin >> T[i];
    }
    int t = pow(10,9)+7;
    if(k==0){
        for(int i=0;i<n;i++){
            S+=T[i];
        }
        cout << S%t << endl;
        return 0;
    }
    while(k>0){
    for(int j=0;j<n;j++){
        S+= ((j+1)*(n-j)*T[j]);
    }
    k--;
    }
    cout << S%t << endl;
    return 0;
}